

.MODEL SMALL
.STACK
.DATA
.CODE

main proc

    ;call read_binary	; binris beolvass szubrutinja

    ;call read_decimal	; decimlis -,,-

    call read_hexa	; hexadecim. -,,-

    mov AL,DL

    call read_hexa

    CMP AL,DL

    JB tovabb

    mov DL,AL

tovabb:
    call write_hexa

    mov AH, 4ch
    int 21h

main endp



CR EQU 13	    ; ld.03
LF EQU 10	    ; ld.03

cr_lf proc

    push DX
    mov DL, CR
    call write_char
    mov DL, LF
    call write_char
    pop DX
    ret

cr_lf endp


read_char proc

    push AX
    mov AH, 8	    ; 1h-rl t lett javtva 8-ra - nem lesz echo
    int 21h
    mov DL, AL

    pop AX
    ret

read_char endp


write_char proc

    push AX
    mov AH, 2h
    int 21h
    pop AX
    ret

write_char endp


write_binary proc

    push AX
    push CX
    push DX
    mov BL,DL
    mov CX, 8

 binary_digit:
    XOR DL,DL
    RCL BL,1
    ADC DL,'0'
    call write_char
    loop binary_digit
    pop DX
    pop CX
    pop BX
    ret

write_binary endp



write_hexa proc

    push CX
    push DX
    mov DH,DL
    mov CL, 4
    SHR DL,CL
    call write_hexa_digit
    mov DL,DH
    AND DL, 0Fh
    call write_hexa_digit
    pop DX
    pop CX
    ret

write_hexa endp


write_hexa_digit proc

    push DX
    CMP DL,10
    JB non_hexa_letter
    ADD DL, 'A'-10-'0'
 non_hexa_letter:
    ADD DL, '0'
    call write_char
    pop DX
    ret

write_hexa_digit endp


write_decimal proc
    push AX
    push CX
    push DX
    push SI
    mov AX, DX
    mov SI, 10
    XOR CX, CX
 decimal_non_zero:
    XOR DX, DX
    DIV si
    push DX
    inc CX
    OR AX, AX
    JNE decimal_non_zero
 decimal_loop:
    pop DX
    call write_hexa_digit
    loop decimal_loop

    pop SI
    pop DX
    pop CX
    pop AX
    ret

write_decimal endp


read_binary proc

    push AX	    ; AX regisztert elmentjk
    XOR AX,AX	    ; nullzzuk tartalmt
 r_b_new:
    call read_char
    CMP DL,'0'	    ; sszehasonltom nullval
    JE r_b_continue ; ha 0, mehet tovbb
    CMP DL,'1'	    ; -,,- eggyel
    JE r_b_continue ; tovbb
    CMP DL,CR	    ; Enter is lehet
    JE r_b_continue ; tovbb
    JMP r_b_new     ; ha nem ment tovbb, mst nyomtunk - jra kri
 r_b_continue:
    call write_char
    CMP DL,CR
    JE r_b_end	    ; ha egyenl
    SUB DL,'0'
    SAL AL,1	    ; Shift Arithmetical Left (egy bittel balra toljuk)
		    ; =KETTVEL SZORZS
    ADD AL,DL
    JMP r_b_new
 r_b_end:
    MOV DL,AL
    pop AX
    ret

read_binary endp


read_decimal proc

    push AX	    ; AX regisztert elmentjk
    push BX
    mov BX,10
    XOR AX,AX	    ; nullzzuk tartalmt
 r_d_new:
    call read_char
    CMP DL,CR
    JE r_d_end	    ; ha egyenl
    SUB DL,'0'
    MUL BL
    ADD AL,DL
    JMP r_d_new
 r_d_end:
    MOV DL,AL
    pop BX
    pop AX
    ret

read_decimal endp


read_hexa proc

    push AX	    ; AX regisztert elmentjk
    push BX
    mov BX,10h
    XOR AX,AX	    ; nullzzuk tartalmt
 r_h_new:
    call read_char
    CMP DL,CR
    JE r_h_end	    ; ha egyenl

    CMP DL,'0'
    JE r_h_continue
    CMP DL,'1'
    JE r_h_continue
    CMP DL,'2'
    JE r_h_continue
    CMP DL,'3'
    JE r_h_continue
    CMP DL,'4'
    JE r_h_continue
    CMP DL,'5'
    JE r_h_continue
    CMP DL,'6'
    JE r_h_continue
    CMP DL,'7'
    JE r_h_continue
    CMP DL,'8'
    JE r_h_continue
    CMP DL,'9'
    JE r_h_continue
    CMP DL,'a'
    JE r_h_continue
    CMP DL,'b'
    JE r_h_continue
    CMP DL,'c'
    JE r_h_continue
    CMP DL,'d'
    JE r_h_continue
    CMP DL,'e'
    JE r_h_continue
    CMP DL,'f'
    JE r_h_continue
    CMP DL,'A'
    JE r_h_continue
    CMP DL,'B'
    JE r_h_continue
    CMP DL,'C'
    JE r_h_continue
    CMP DL,'D'
    JE r_h_continue
    CMP DL,'E'
    JE r_h_continue
    CMP DL,'F'
    JE r_h_continue

    JMP r_h_new     ; ha nem hexa szm, visszaugrik

 r_h_continue:
    call write_char
    call upcase
    SUB DL,'0'
    CMP DL,9
    JBE r_h_decimal
    SUB DL, 'A'-'0'-10
 r_h_decimal:
    MUL BL
    ADD AL,DL
    JMP r_h_new
 r_h_end:
    MOV DL,AL
    pop BX
    pop AX
    ret

read_hexa endp


upcase proc

    CMP DL,'a'
    JB upcase_end
    CMP DL,'z'
    JA upcase_end
    SUB DL,'a'-'A'
 upcase_end:
    ret

upcase endp


compare proc

    push AX
    push BX

    call read_hexa

    mov ax,dx

    call read_hexa

    mov ax,cx

    cmp dx,cx
    JB kiir_masodik
    JA kiir_elso

    pop AX
    pop BX
    ret

compare endp


proc kiir_elso

    ; ...

kiir_elso endp

    ; ...

proc kiir_masodik


kiir_masodik endp


END main
