; Feladat: read_binary talaktsa gy, hogy csak a 0-t s az 1-et fogadja el

.MODEL SMALL
.STACK
.DATA
    adat    DB	"Ez egy szveg",10,13,"msodik sor",10,13,0
    adat1   DB	'a'
.CODE

main proc

    mov AX, dgroup
    mov DS, AX
    ; ezt mindig kell ha adatszegmenset akarunk hasznlni

    LEA BX, adat

    ;call write_string	; vmirt szar

    ;call read_binary	; binris beolvass szubrutinja

    ;call read_decimal	; decimlis -,,-

    ;call read_hexa	; hexadecim. -,,-

    ;call cr_lf		; ld.023

    ;call write_char	; ld.022

    ;XOR DH,DH		; ld.03

    ;call cr_lf

    ;call write_binary	; ld.03

    ;call cr_lf

    ;call write_decimal	; ld.03

    call cr_lf

    call write_char	; ld.03

    mov AH, 4ch
    int 21h

main endp



CR EQU 13	    ; ld.03
LF EQU 10	    ; ld.03

cr_lf proc

    push DX
    mov DL, CR
    call write_char
    mov DL, LF
    call write_char
    pop DX
    ret

cr_lf endp


read_char proc

    push AX
    mov AH, 8	    ; 1h-rl t lett javtva 8-ra - nem lesz echo
    int 21h
    mov DL, AL

    pop AX
    ret

read_char endp


write_char proc

    push AX
    mov AH, 2h
    int 21h
    pop AX
    ret

write_char endp


write_binary proc

    push AX
    push CX
    push DX
    mov BL,DL
    mov CX, 8

 binary_digit:
    XOR DL,DL
    RCL BL,1
    ADC DL,'0'
    call write_char
    loop binary_digit
    pop DX
    pop CX
    pop BX
    ret

write_binary endp



write_hexa proc

    push CX
    push DX
    mov DH,DL
    mov CL, 4
    SHR DL,CL
    call write_hexa_digit
    mov DL,DH
    AND DL, 0Fh
    call write_hexa_digit
    pop DX
    pop CX
    ret

write_hexa endp


write_hexa_digit proc

    push DX
    CMP DL,10
    JB non_hexa_letter
    ADD DL, 'A'-10-'0'
 non_hexa_letter:
    ADD DL, '0'
    call write_char
    pop DX
    ret

write_hexa_digit endp


write_decimal proc
    push AX
    push CX
    push DX
    push SI
    mov AX, DX
    mov SI, 10
    XOR CX, CX
 decimal_non_zero:
    XOR DX, DX
    DIV si
    push DX
    inc CX
    OR AX, AX
    JNE decimal_non_zero
 decimal_loop:
    pop DX
    call write_hexa_digit
    loop decimal_loop

    pop SI
    pop DX
    pop CX
    pop AX
    ret

write_decimal endp


read_binary proc

    push AX	    ; AX regisztert elmentjk
    XOR AX,AX	    ; nullzzuk tartalmt
 r_b_new:
    call read_char
    CMP DL,'0'	    ; sszehasonltom nullval
    JE r_b_continue ; ha 0, mehet tovbb
    CMP DL,'1'	    ; -,,- eggyel
    JE r_b_continue ; tovbb
    CMP DL,CR	    ; Enter is lehet
    JE r_b_continue ; tovbb
    JMP r_b_new     ; ha nem ment tovbb, mst nyomtunk - jra kri
 r_b_continue:
    call write_char
    CMP DL,CR
    JE r_b_end	    ; ha egyenl
    SUB DL,'0'
    SAL AL,1	    ; Shift Arithmetical Left (egy bittel balra toljuk)
		    ; =KETTVEL SZORZS
    ADD AL,DL
    JMP r_b_new
 r_b_end:
    MOV DL,AL
    pop AX
    ret

read_binary endp


read_decimal proc

    push AX	    ; AX regisztert elmentjk
    push BX
    mov BX,10
    XOR AX,AX	    ; nullzzuk tartalmt
 r_d_new:
    call read_char
    CMP DL,CR
    JE r_d_end	    ; ha egyenl
    SUB DL,'0'
    MUL BL
    ADD AL,DL
    JMP r_d_new
 r_d_end:
    MOV DL,AL
    pop BX
    pop AX
    ret

read_decimal endp


read_hexa proc

    push AX	    ; AX regisztert elmentjk
    push BX
    mov BX,10h
    XOR AX,AX	    ; nullzzuk tartalmt
 r_h_new:
    call read_char
    CMP DL,CR
    JE r_h_end	    ; ha egyenl
    call upcase
    SUB DL,'0'
    CMP DL,9
    JBE r_h_decimal
    SUB DL, 'A'-'0'-10
 r_h_decimal:
    MUL BL
    ADD AL,DL
    JMP r_h_new
 r_h_end:
    MOV DL,AL
    pop BX
    pop AX
    ret

read_hexa endp


upcase proc

    CMP DL,'a'
    JB upcase_end
    CMP DL,'z'
    JA upcase_end
    SUB DL,'a'-'A'
 upcase_end:
    ret

upcase endp


write_string proc

    push BX
    push DX

 w_s_uj:
    mov DL, [BX]
    OR DL,DL
    JZ w_s_vege
    call write_char
    inc BX
    jmp w_s_uj
 w_s_vege:

    pop DX
    pop BX

write_string endp



END main
