DOSSEG
.MODEL SMALL
.STACK
.CODE


main proc
  call read_binary
  ;call read_decimal
  ;call read_hexa
  call cr_lf
  call write_char
  XOR DH,DH	 ;ez a DH-t 0-ra teszi	 gyorsabb mint a 0 beletenni
  call cr_lf
  call write_binary
  call cr_lf
  call write_decimal
  call cr_lf
  call write_hexa
  mov AH,4ch
  int 21h
main endp

upcase proc   ;nagybetuve konvertalja kisbetut
  CMP DL,'a'
  JB upcase_end   ;ha kisebb
  CMP DL,'z'
  JA upcase_end   ;ha nagyobb
  SUB DL, 'a'-'A'
  upcase_end:
    ret
upcase endp

read_hexa proc
  PUSH AX
  PUSH BX
  mov BL, 10h
  XOR AX, AX
  read_hexa_new:
    call read_char
    CMP DL,CR
    JE read_hexa_end
    call upcase
    SUB DL,'0'
    CMP DL,9
    JBE read_hexa_decimal	;ha kisebb vagy egyenlo
    SUB DL,'A'-'0'-10
  read_hexa_decimal:
    MUL BL
    ADD AL,DL
    JMP read_hexa_new
  read_hexa_end:
    mov DL,AL
    pop BX
    pop AX
    ret
read_hexa endp

read_decimal proc
  PUSH AX
  PUSH BX
  mov BL, 10
  XOR AX, AX
  read_decimal_new:
    call read_char
    CMP DL,CR
    JE read_decimal_end
    SUB DL,'0'
    MUL BL
    ADD AL,DL
    JMP read_decimal_new
  read_decimal_end:
    mov DL,AL
    pop BX
    pop AX
    ret
read_decimal endp

read_binary proc     ;modositani ugy hogy csak 0 1-et fogadjon
  PUSH AX
  XOR AX, AX
  read_binary_new:
  new_char:
    call read_char

    CMP DL,CR
    JE read_binary_end

    CMP DL,'0'
    JB new_char

    CMP DL,'1'
    JA new_char

    call write_char


    SUB DL,'0'
    SAL AL,1
    ADD AL,DL
    JMP read_binary_new
  read_binary_end:
    mov DL,AL
    pop AX
    ret
read_binary endp

write_binary proc
  PUSH DX
  PUSH CX
  PUSH BX
  mov BL,DL
  mov CX,8 ;ciklus miatt
  binary_digit:
    XOR DL,DL
    RCL BL,1	 ;rotls
    ADC DL,'0'
    call write_char
  loop binary_digit  ;amig a CX nem 0
  pop BX
  pop CX
  pop DX
  ret
write_binary endp

write_hexa proc
  PUSH CX
  PUSH DX
  mov DH,DL
  mov CL,4
  SHR DL,CL	;jobbra shiftels
  call write_hexa_digit
  mov DL,DH
  AND DL,0Fh   ;ez gyakorlatilag 0001111b maszkols, ekkora csak a byte msodik fele marad meg
  call write_hexa_digit
  pop DX
  pop CX
  ret
write_hexa endp

write_hexa_digit proc
  push DX
  CMP DL,10  ;statuszbiteket beallitja DL erteke szerint: negativ, nulla, pozitiv
  JB non_hexa_letter
  ADD DL,'A'-'0'-10
  non_hexa_letter:
    ADD DL,'0'
    call write_char
    pop DX
    ret
write_hexa_digit endp

write_decimal proc
  PUSH AX
  PUSH CX
  PUSH DX
  PUSH SI
  mov AX,DX
  mov SI,10
  XOR CX,CX
  decimal_non_zero:
    XOR DX,DX
    DIV SI
    PUSH DX
    INC CX
    OR AX,AX   ;ez itt lehe nm jo
    JNE decimal_non_zero ;JNZ is j lenne    valami gebasz van itt
  decimal_loop:
    POP DX
    call write_hexa_digit
  loop decimal_loop	 ;mivel CXet inkrementltuk ezrt azt nem kell belni
  POP SI
  POP DX
  POP CX
  POP AX
write_decimal endp

read_char proc
  push AX  ;AX tartalmat stackre helyezi
  mov AH, 8
  int 21h
  mov DL, AL
  pop AX
  ret ;viszateres
read_char endp

write_char proc
  push AX
  mov AH,2h
  int 21h
  pop AX
  ret
write_char endp

CR EQU 13 ;konstans ertekadas
LF EQU 10

cr_lf proc
 push DX
 mov DL,CR
 call write_char
 mov DL,LF
 call write_char
 pop DX
 ret
cr_lf endp

END main
